# mididings - Table of Contents

- Getting Started

  Some simple examples. If you have no idea what mididings is all about, this is the place to start.

  - Anatomy of a mididings script
  - Examples
    - Example 1
    - Example 2: connecting units
    - Example 3: multiple scenes
  - Command line usage
- Basics
  - Connections
  - Note names and ranges
  - Port numbers and names
  - Miscellaneous
- Core Module Reference – mididings

  Documentation of global functions and classes defined in the mididings module.

  - Functions
  - Classes
  - Constants
- Units Reference – mididings

  Documentation of event-processing units defined in the mididings module.

  - Filters
  - Splits
  - Modifiers
  - Generators
  - Function Calls
  - Miscellaneous
- Submodules Reference

  These modules contain functions and classes to be used in regular Python code, for example within the Call() and Process() units.

  - event – mididings.event
  - engine – mididings.engine
  - util – mididings.util
- Extra Module Reference – mididings.extra.*

  The mididings.extra package contains functions which require additional dependencies, or which just didn't fit anywhere else. Incidentally, this includes some of mididings' coolest features ;)

  - Units
  - Hooks
  - General MIDI definitions
- livedings
- Examples
  - output.py - uses the Output() unit to simplify MIDI routing and sending program changes
  - skeleton.py - the basic structure of a complex setup with multiple scenes and various other features
  - process.py - shows how to process MIDI events in Python
  - hooks.py - demonstrates the use of hooks extending mididings' functionality
  - aeolus.py - Aeolus stop control using one controller per stop
  - klick.py - uses SendOSC() to start/stop klick
  - router.py - a simple OSC-controlled MIDI router